#include <iostream>
#include <vector>
#include <map>

using namespace std;
int main() {
    int n, k;
    cin >> n >> k;

    map<int, int> vrednosti;
    vector<int> zaOutput;

    int brojac = 0;

    for (int i = 0; i < n; i++) {
        int ulaz;
        cin >> ulaz;
        if (vrednosti[ulaz] == k) {
            continue;
        }
        vrednosti[ulaz] = vrednosti[ulaz]+1;

        if (vrednosti[ulaz] == k) {
            zaOutput.push_back(ulaz);
            brojac++;
        }
    }

    cout << brojac << endl;
    for (int i = 0; i < zaOutput.size(); i++) {
        cout << zaOutput[i] << " ";
    }


    return 0;
}